(* ESEMPI *)
let (classe: cdecl) = Class("point",["a";"b"],("Object",[]),
 ([("x",Newloc(Den "a"));("y", Newloc(Den "b"))], 
  [("getx", Fun([],Val(Den "x"))); 
   ("gety", Fun([],Val(Den "y")));
   ("move", 
       Proc(["c";"d"],
         ([],[],
	   [Assign(Den "x", Den "c");
            Assign(Den "y", Den "d")])))],
  []));;
     
let (newobj: (ide * exp) list) = [("p1", New("point",[Eint 1; Eint 3]))];;

let (comobj: com list) = [Call(Field(Den "p1","move"),
     [Eint 38; Eint 43])];;
     
let (sottoclasse: cdecl) = Class("point3",["a";"b";"c"],("point",["a";"b"]),
  ([("z",Newloc(Den "c"))],
   [("getz", Fun([],Val(Den "z")));
    ("move", 
       Proc(["c";"d";"e"],
         ([],[],
	 [Assign(Den "x", Den "c");
          Assign(Den "z", Den "e");
          Assign(Den "y", Den "d")])))],
   []));;
     
let (nobj: (ide * exp) list) = [("p2", New("point3",[Eint 1; Eint 3; 
   Eint 105]))];;

let (como: com list) = [Call(Field(Den "p2","move"),
     [Eint 38; Eint 43; Eint 1012])];; 
     
let (sottoclasse21: cdecl) = Class("point3",["a";"b";"c"],("point",["a";"b"]),
  ([("z",Newloc(Den "c"))],
   [("getz", Fun([],Val(Den "z")));
    ("move", 
       Proc(["c";"d";"e"],
         ([],[],
	 [Assign(Den "x", Den "c");
          Assign(Den "z", Den "e");
          Assign(Den "y", Den "d")])));
    ("ignorez",
       Proc(["ref2"],
          ([],[],
	  [Assign(Den "ref2", New("point",[Val(Den "x");Val(Den "y")]))])))],
   []));;
   
let (punti: cdecl list) = [classe; sottoclasse21];;

	 
let (dichiarazioni: (ide * exp) list) = 
  [("punto3_1", Newloc(New("point3",[Eint 1; Eint 3; Eint 105])));
   ("punto2_1",Newloc(New("point",[Eint 0; Eint 0])));
   ("punto3_2", Newloc(Val(Den "punto3_1")))];;
   
let (comandi: com list) =   
[Call(Field(Val(Den "punto3_1"),"move"),
     [Eint 38; Eint 43; Eint 1012]);
 Call(Field(Val(Den "punto3_2"),"ignorez"),[Den "punto2_1"])
   ];;
   
let expr = Appl(Field(Val(Den "punto2_1"),"getx"),[]);;

(* Funzioni che restituiscono nuovi oggetti *)
(* in ML
# class point (a,b) = object
  val x = ref(a)
  val y = ref(b)
  method getx = !x
  method gety = !y
  method move (c,d) = x := !x + c; y := !y + d
  end;;
class point :
  int * int ->
  object
    val x : int ref
    val y : int ref
    method getx : int
    method gety : int
    method move : int * int -> unit
  end
  
# class point3 (a,b,c) = object
  inherit point (a,b)
  val z = ref(c)
  method getz = !z
  method move1 (c,d,e) = x := !x + c; y := !y + d; z := !z + e
  method ignorez w =  w := new point (!x,!y)
  end;;
class point3 :
  int * int * int ->
  object
    val x : int ref
    val y : int ref
    val z : int ref
    method getx : int
    method gety : int
    method getz : int
    method ignorez : point ref -> unit
    method move : int * int -> unit
    method move1 : int * int * int -> unit
  end
# let punto31 = ref(new point3 (1,3,105));;
val punto31 : point3 ref = {contents=<obj>}
# let punto21 = ref(new point (0,0));;
val punto21 : point ref = {contents=<obj>}
# let punto32 = ref(!punto31);;
val punto32 : point3 ref = {contents=<obj>}
# !punto31#move1 (38,43,1012);;
# !punto32#ignorez (punto21);;
# !punto21#getx;;
- : int = 39 *)


let (classe1: cdecl) = Class("point",["a";"b"],("Object",[]),
 ([("x",Newloc(Den "a"));("y", Newloc(Den "b"))], 
  [("getx", Fun([],Val(Den "x"))); 
   ("gety", Fun([],Val(Den "y")));
   ("move", 
       Proc(["c";"d"],
         ([],[],
	   [Assign(Den "x", Sum(Val(Den "x"),Den "c"));
            Assign(Den "y", Sum(Val(Den "y"),Den "d"))])))],
  []));;
  
let (sottoclasse1: cdecl) = Class("point3",["a";"b";"c"],("point",["a";"b"]),
  ([("z",Newloc(Den "c"))],
   [("getz", Fun([],Val(Den "z")));
    ("move", 
       Proc(["c";"d";"e"],
         ([],[],
	 [Assign(Den "x", Sum(Val(Den "x"),Den "c"));
          Assign(Den "z", Sum(Val(Den "z"),Den "e"));
          Assign(Den "y", Sum(Val(Den "y"),Den "d"))])));
    ("projectxy",
       Fun([], 
      New("point",[Val(Den "x");Val(Den "y")])))],
   []));;
   
let (punti1: cdecl list) = [classe1; sottoclasse1];; 

      
let (dichiarazioni1: (ide * exp) list) = 
   [("punto3_1", Newloc(New("point3",[Eint 1; Eint 3; Eint 105])));
   ("punto3_2", Newloc(Val(Den "punto3_1")))];;
   
let (comandi1: com list) =   
[Call(Field(Val(Den "punto3_1"),"move"),
     [Eint 38; Eint 43; Eint 1012])];;
     
let (newd2: (ide * exp) list) = 
  [("punto2_1",Appl(Field(Val(Den "punto3_2"),"projectxy"),[]))];;

let expr1 = Appl(Field(Den "punto2_1","getx"),[]);;

(* esempi che usano this *)

let (classe2: cdecl) = Class("point",["a";"b"],("Object",[]),
 ([("x",Newloc(Den "a"));("y", Newloc(Den "b"))], 
  [("getx", Fun([],Val(Field(This, "x")))); 
   ("gety", Fun([],Val(Field(This, "y"))));
   ("move", 
       Proc(["c";"d"],
         ([],[],
	   [Assign(Field(This, "x"), Sum(Val(Field(This, "x")),Den "c"));
            Assign(Field(This, "y"), Sum(Val(Field(This, "y")),Den "d"))])))],
  []));;
  
let (sottoclasse2: cdecl) = Class("point3",["a";"b";"c"],("point",["a";"b"]),
  ([("z",Newloc(Den "c"))],
   [("getz", Fun([],Val(Field(This, "z"))));
    ("move", 
       Proc(["c";"d";"e"],
         ([],[],
	 [Assign(Field(This, "x"), Sum(Val(Field(This, "x")),Den "c"));
          Assign(Field(This, "z"), Sum(Val(Field(This, "z")),Den "e"));
          Assign(Field(This, "y"), Sum(Val(Field(This, "y")),Den "d"))])));
    ("projectxy",
       Fun([], 
      New("point",[Val(Field(This, "x"));Val(Field(This, "y"))])))],
   []));;

let (punti2: cdecl list) = [classe2; sottoclasse2];; 

(* esempi per il garbage collector *)
let (blocco: block) =
[("z", Newloc(Eint 1)); ("w", Newloc(New("point3",[Eint 0; Eint 0; Eint 0]))) ],
[],
[While(Not(Eq(Val(Den "z"), Eint 10)),
	     [Assign(Den "w", New("point3",
	             [Val(Den "z");Val(Den "z") ;Val(Den "z")]));
	     Assign(Den "z", Sum(Val(Den "z"),Eint 1))]
	   )] ;;