

type labeledconstruct = 
   | Expr1 of exp 
   | Expr2 of exp
   | Exprd1 of exp
   | Exprd2 of exp
   | Com1 of com
   | Com2 of com
   | Coml of labeledconstruct list

let (continuation: labeledconstruct stack) = 
     emptystack(cframesize,Expr1(Eint(0)))

let (tempstack: eval stack) = 
     emptystack(tframesize,Novalue)
     
let (tempdstack: dval stack) = 
     emptystack(tdframesize,Unbound)

let globalstore = ref(emptystore(Undefined))     
     
let labelcom (dl: com list) = let dlr = ref(dl) in
	let ldlr = ref([]) in
	while not (!dlr = []) do
	 let i = List.hd !dlr in
	 ldlr := !ldlr @ [Com1(i)];
	 dlr := List.tl !dlr
	done;
	Coml(!ldlr)