module type MPILA =
   sig
     type 'a stack
     val emptystack : int * 'a -> 'a stack
     val push : 'a * 'a stack  -> unit
     val pop : 'a stack -> unit
     val top : 'a stack -> 'a
     val empty : 'a stack -> bool
     val lungh : 'a stack -> int
     val svuota: 'a stack -> unit
     val access: 'a stack * int -> 'a
     val setta: 'a stack * int * 'a -> unit
     exception Emptystack
     exception Fullstack
     exception Wrongaccess
   end